#include <stdio.h>
#include <math.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>

clock_t clock(void);
double drand48();
double erand48();
int * funkrec;
int indexMinMax, indexCount;
int DeBugEnd = 0, DeBugStep = 0, DeBugOutCnt = 0, DeBugOut = 1;
int FSEOF = 0;
#define eee 2.71828182945904523536028747135
#define pipipi 3.1415926535897932384626433832795
struct procrec {int number; int procID; int pipeID, pipeID2;
                char * types; int ** refs;
                struct procrec * next;};
struct procrec * procretlist = 0;
int connOK = 0;
int lastreadtype = 0, parentread = -1, parentwrite = -1;
fd_set readyforaccept;
FILE * StdIn=stdin, *StdOut=stdout, *StdErr=stderr;

void deb(int Zeile)
{ int Nr;
  DeBugStep--;
  if(DeBugEnd==0 && DeBugStep<=0)
  { DeBugOutCnt++;
    fprintf(StdErr,"Nr %3d Zeile %d, 0=exit, 1,2=out,off, 3=step, 8,9=continue: ", DeBugOutCnt, Zeile);
    scanf(" %d",&Nr);
         if(Nr==0) exit(0);
    else if(Nr==1) DeBugOut=1;
    else if(Nr==2) DeBugOut=0;
    else if(Nr==8) DeBugEnd=8;
    else if(Nr==9) DeBugEnd=1;
    else if(Nr==3)
    { fprintf(StdErr,"Number of steps = ");
      scanf("%d",&DeBugStep);
    }
  } else if(DeBugEnd==8)
  { fprintf(StdErr,"Zeile %d\n", Zeile);
  }
}

void perr(int was,int wo)
{if(was==1)
{fprintf(stderr,"line %d: Array bounds out of range\n",wo);}
else if(was==2)
{fprintf(stderr,"line %d: Values out of range\n",wo);}
else if(was==3)
{fprintf(stderr,"line %d: Cycle out of range\n",wo);}
else if(was==4)
{fprintf(stderr,"line %d: Gauge out of range\n",wo);}
else if(was==5)
{fprintf(stderr,"line %d: Text too long\n",wo);}
else if(was==6)
{fprintf(stderr,"line %d: Semaphore argument negativ\n",wo);}
else
{fprintf(stderr,"line %d: Undefined Error!\n",wo);}
exit(1);}

/* Liest Anzahl Zeichen von der Verbindung conn */
/* Verzoegert, bis Anzahl Zeichen vorhanden */
char * readxn(int conn, int Anzahl)
{ char * c1; char * c2;
  int Gelesen, len;
  len = Anzahl+1;
  c1 = (char *)calloc(len,sizeof(char));
  Gelesen = read(conn,c1,Anzahl);
  if(Gelesen<0)
  { free(c1);
    return 0;
  } else if(Gelesen<Anzahl)
  { while(Gelesen<Anzahl)
    { c2 = (char *)calloc(Anzahl+1,sizeof(char));
      Gelesen += read(conn,c2,Anzahl-Gelesen);
      strcat(c1,c2);
      free(c2);
  } }
  return c1;
}

/* Liest einen logischen Wert von conn; Feldbreite = 1 */
int readxnb(int conn)
{ char * Text; int Wert;
  Text = readxn(conn,1);
  if(Text == 0)
  { connOK = 0; return 0;}
  else connOK = 1;
  sscanf(Text,"%d",&Wert);
  free(Text);
  if(Wert==0) return 0;
  else return 1;
}

int Readtype(int conn, int TypeValue, char * errTxt)
{ char * Text; int Type;
  Text = readxn(conn,8);
  sscanf(Text,"%d",&Type);
  free(Text);
  if(Type!=TypeValue)
  { fprintf(stderr,
    "Type error in read %s, descriptor = %d, type == %d\n"
    ,errTxt,conn,Type);
    lastreadtype = 0;
  } else
  lastreadtype = Type;
  return Type;
}
char * readerror(int conn, int Anzahl, char * errTxt)
{ char * Text; 
  Text = readxn(conn,Anzahl);
  if(Text == 0)
  { connOK = 0; lastreadtype = 0;
    fprintf(stderr,
    "Read error in read %s, descriptor = %d\n",errTxt,conn);
    return 0;
  }
  else
    connOK = 1;
  return Text;
}
/* Liest logischen Wert von conn; 
   Format 8 Bytes "       1" + 1 Bytes Zahlwert */
char readb(int conn)
{ char * Text; char Wert;
  Readtype(conn, 1, "boolean");
  Text = readerror(conn, 1, "boolean");
  if((int)Text[0]==0)Wert=0;
  else Wert = 1;
  free(Text);
  return Wert;
}
/* Liest Zeichen von conn; 
   Format 8 Bytes "       2" + 1 Bytes Zahlwert */
char readc(int conn)
{ char * Text; char Wert;
  Readtype(conn, 2, "character");
  Text = readerror(conn, 1, "character");
  if(Text!=0)sscanf(Text,"%c",&Wert);
  free(Text);
  return Wert;
}
/* Liest eine ganze Zahl von conn; 
   Format 8 Bytes "       3" + 32 Bytes Zahlwert */
int readd(int conn)
{ char * Text; int Wert;
  Readtype(conn, 3, "integer");
  Text = readerror(conn, 32, "integer");
  if(Text!=0)sscanf(Text,"%d",&Wert);
  free(Text);
  return Wert;
}
/* Liest eine real Zahl von conn; 
   Format 8 Bytes "       4" + 32 Bytes Zahlwert */
double readf(int conn)
{ char * Text; double Wert;
  Readtype(conn, 4, "real");
  Text = readerror(conn, 32, "real");
  if(Text!=0)sscanf(Text,"%lf",&Wert);
  free(Text);
  return Wert;
}
/* Liest einen Text, erzeugt mit calloc diesen Text
   Format 8 Bytes (Textlnge + 1000) + Text */
char * readt(int conn)
{ char * Text;
  int Anzahl;
  Text = readxn(conn,8);
  if(Text == 0)
  { connOK = 0; return (char *)calloc(1,sizeof(char));}
  else connOK = 1;
  sscanf(Text,"%d",&Anzahl);
  free(Text);
  if(Anzahl<1000)
  { fprintf(stderr,"Type error in read text(%d,%d,...)\n",conn,Anzahl);
    lastreadtype = 0;
  }
  lastreadtype = 1000;
  return readxn(conn,Anzahl-1000);
}

/* Schreibt Text auf conn; Format: 8 Bytes (Lnge+1000) + Text */
int writet(int conn, char* Text)
{ char h1[10]; int Len; int Max = 5000;
  Len = strlen(Text);
  sprintf(h1, "%8d%c", Len+1000, '\0');
  write(conn, h1, 8);
//fprintf(stderr,"writet: %d, %d, \"%s\"\n",conn, Len, Text);
  if(Len<Max)
    write(conn, Text, Len);
  else 
  { while(Len>Max)
    { if(write(conn, Text, Max)!=Max)
         fprintf(stderr,"Error in write text(%d,%s)\n",conn,Text);
      Len -= Max;
      Text += Max;
    }
    write(conn, Text, Len);
} }

/* Gibt Text auf conn aus; 
   Falls Fehler -> Meldung auf stderr */
int writeError(int conn, char * text, int len, char * errTxt)
{ if(write(conn,text,len)!=len)
  { fprintf(stderr,"Error in write %s (%d,..)",errTxt,conn);
    return -1;
  }
  return 0;
}

/* Schreibt logischen Wert auf conn; 
   Format: 8 Bytes "       1" + 1 Byte Wert (0 oder 1) */
char writeb(int conn, char Wert)
{ char text[2];
  writeError(conn, "       1", 8, "boolean");
  sprintf(text,"%1c",Wert);
  return writeError(conn, text, 1, "boolean");
}

/* Schreibt Zeichen auf conn; 
   Format: 8 Bytes "       2" + 1 Byte Wert */
int writec(int conn, char Wert)
{ char text[2];
  writeError(conn, "       2", 8, "character");
  sprintf(text,"%1c",Wert);
  return writeError(conn, text, 1, "character");
}

/* Schreibt ganze Zahl auf conn; 
   Format: 8 Bytes "       3" + 32 Byte Zahl */
int writed(int conn, int Wert)
{ char text[34];
  writeError(conn, "       3", 8, "integer");
  sprintf(text,"%32d",Wert);
  return writeError(conn, text, 32, "integer");
}

/* Schreibt real Zahl (double) auf conn; 
   Format: 8 Bytes "       4" + 32 Byte Zahl */
int writef(int conn, double Wert)
{ char text[34];
  writeError(conn, "       4", 8, "real");
  sprintf(text,"%32lf",Wert);
  return writeError(conn, text, 32, "real");
}


/*** TCP-Verbindungen ****/
int verbinde(int port, const char* server) {
  struct hostent *remote;		   /* Adressinfo zum Server */
  int sock, sock2;                         /* der Socket */
  struct sockaddr_in adr, adr2;		   /* Strukturen fuer Adressen */
  int adrlen;				   /* Hilfsvariable */

  connOK = 0;   /* Verbindungsaufbau ist immer falsch, ausser .. */
  sock = socket (AF_INET, SOCK_STREAM, 0); /* TCP-Socket erzeugen */
  if(sock<0) return -1;			   /* keinen Socket erhalten, unwahrscheinlich */
  adr.sin_family      = AF_INET;	   /* IP-Familie */
  adr.sin_port        = htons(port);	   /* der Port in network byte order*/
  if(server) /* server=="ServerName", vom Client aufgerufen*/
  { remote = gethostbyname(server);                                  /* Info zum Server holen */
    if(remote==0) return -4;		                               /* no such name */
    adr.sin_addr.s_addr = *((long*)*(remote->h_addr_list));          /* IP-Adresse des Servers */
    if(connect(sock,(struct sockaddr*)&adr,sizeof(adr))<0) return -5;/* Verbindungsaufbauwunsch an Server */
    connOK = 1;      /* Verbindungsaufbau geglueckt */
    return sock;
  }
  else /* server==0, vom Server aufgerufen*/
  { adr.sin_addr.s_addr = htonl(INADDR_ANY);                         /* wir sind Server, lokale Adresse ist egal */
    adrlen = sizeof(adr);
    if(bind(sock,(struct sockaddr*)&adr,sizeof(adr))<0) return -4;   /* Server kann Port nicht kriegen */
    if(listen(sock,5)<0) return -2;                                  /* Server kann nicht auf Verbindungen warten */
//    sock2 = accept(sock,(struct sockaddr*)&adr2,&adrlen);            /* auf Verbindungswunsch warten */
//    if(sock2<0) return -3;                                           /* Verbindungsannahme lief schief */
//    close(sock);
    connOK = 1;      /* Verbindungsaufbau geglueckt */
//    return sock2;
    return sock;
  }
}
/*** TCP-Verbindungen ****/
int akzeptiere(int sock) {
  int sock2;			/* der Socket */
  int adrlen;			/* Hilfsvariable */
  connOK = 0;   /* Verbindungsaufbau ist immer falsch, ausser .. */
  sock2 = accept(sock,(struct sockaddr*)0,(int*)0);            /* auf Verbindungswunsch warten */
  if(sock2<0) return -3;	/* Verbindungsannahme lief schief */
  connOK = 1;			/* ...Verbindungsaufbau geglueckt */
  return sock2;
}
/*** select ein Ereignis  ***/
int selectforready(int sock1,int sock2,int sock3,int sock4,int sock5,double time)
{ int maxsock = 0, selret=0;
  struct timeval to;
  FD_ZERO(&readyforaccept);
  if(sock1!=-1) FD_SET(sock1,&readyforaccept);
  if(sock1>maxsock)maxsock=sock1;
  if(sock2!=-1) FD_SET(sock2,&readyforaccept);
  if(sock2>maxsock)maxsock=sock2;
  if(sock3!=-1) FD_SET(sock3,&readyforaccept);
  if(sock3>maxsock)maxsock=sock3;
  if(sock4!=-1) FD_SET(sock4,&readyforaccept);
  if(sock4>maxsock)maxsock=sock4;
  if(sock5!=-1) FD_SET(sock5,&readyforaccept);
  if(sock5>maxsock)maxsock=sock5;
  if(time>=0.0)
  { to.tv_sec = (int)time;
    to.tv_usec = 0;
    if((selret=select(maxsock+1,&readyforaccept,(fd_set*)0,
		(fd_set*)0,&to))<0)
    { fprintf(stderr,"Error in \"test ... \"");
    }
  }
   else 
  { if((selret=select(maxsock+1,&readyforaccept,(fd_set*)0,
		(fd_set*)0,(struct timeval *) 0))<0)
    { fprintf(stderr,"Error in \"test ... \"");
    }
  }
  return selret;
}

int absi(int Wert)
{ return (Wert>=0 ? Wert : - Wert);
}

double absr(double Wert)
{ return (Wert>=0 ? Wert : - Wert);
}

double absc(double Wert)  /* noch nicht definiert !! */
{ return (Wert>=0 ? Wert : - Wert);
}

int seq(int von, int ist, int bis, int wo)
{if(ist<von||ist>bis)perr(2,wo);
return ist;}

int gauge(int von, int ist, int bis, int wo)
{ if(bis<von) perr(4,wo);
  else if(ist<von) return von;
  else if(ist>bis) return bis;
  else return ist;}

double gauger(double von, double ist, double bis, int wo)
{ if(bis<von) perr(4,wo);
  else if(ist<von) return von;
  else if(ist>bis) return bis;
  else return ist;}

int cycle(int von, int ist, int bis, int wo)
{ if(bis<von) perr(3,wo);
  else if(ist==von || ist == bis) return ist;
  else if(ist>von) 
  return ist-((int)((ist-von)/(bis-von+1)))*(bis-von+1);
  else return ist+(((int)((von-ist-1)/(bis-von+1)))+1)*(bis-von+1);
}

double cycler(double von, double ist, double bis, int wo)
{ if(bis<von) perr(3,wo);
  else if(ist==von || ist == bis) return ist;
  else if(ist>von) return ist-((int)((ist-von)/(bis-von)))*(bis-von);
  else return bis-von+ist+((int)((von-ist)/(bis-von)))*(bis-von);
}

int readValues(int von, int bis, char * Soll[], char * Text,int wo)
{ int i;
  while(1)
  { for(i=von;i<=bis;i++)
      if (strcasecmp(Soll[i],Text)==0)
        { return i;}
    fprintf(stderr,"line %d: Value \"%s\" incorrect. Use one of:\n",wo,Text);
    for(i=von;i<bis;i++)
    fprintf(stderr,"%s, ",Soll[i]);
    fprintf(stderr,"%s.\n",Soll[bis]);
    fscanf(StdIn,"%s",Text);
  }
}

int rest(int i, int c)
{ return i<0?c-1+((i+1)%c):(i%c);
}

char * cn(char Zeichen, int Anzahl) /* char n times to text */
{ char * Text; int i;
  Text = (char *) calloc(Anzahl+1, sizeof(char));
  for (i=0;i<Anzahl;i++) Text[i]=Zeichen;
  return Text;
}

char * cx(char Zeichen) /* char to text */
{ char * Text;
  Text = (char *) calloc(2, sizeof(char));
  Text[0]=Zeichen;
  return Text;
}

char * xax(char * Text1) /* text to alloc text */
{ char * Text;
  Text = (char *) calloc(strlen(Text1)+1, sizeof(char));
  strcat(Text,Text1);
  return Text;
}

char * xaxn(char * Text1, int Laenge) /* text to alloc text >= n */
{ char * Text; int LText1;
  LText1 = strlen(Text1);
  if(LText1<Laenge) LText1 = Laenge;
  Text = (char *) calloc(LText1+1, sizeof(char));
  strcat(Text,Text1);
  return Text;
}

char * xn1(char * Text1, int Anzahl ) /* text n times to text */
{ char * Text; int i, j, Len, LenAnz; char ch;
  Len = strlen(Text1);
  LenAnz = Len*Anzahl;
  Text = (char *) calloc(Anzahl*Len+1, sizeof(char));
  for (i=0;i<Len;i++) 
  { ch = Text1[i];
    for(j=i;j<LenAnz;j+=Len)
    Text[j] = ch;
  }
  return Text;
}

char * xn0(char * Text1, int Anzahl ) /* text n times to text */
{ char * Text;                        /* free text */
  Text = xn1(Text1, Anzahl);
  free(Text1);
  return Text;
}

char * cxn(char Zeichen, char * Text, int Nr )/* Zeichen in text[Nr] */
{ if(Nr>0 && Nr<=strlen(Text))
  Text[Nr-1] = Zeichen;
  return Text;
}

char * cxnn(char Zeichen, char * Text, int Nr1, int Nr2 )/* Zeichen in text[Nr] */
{ int Nr, L1;
  Nr = Nr1; L1 = strlen(Text);
  while(Nr>0 && Nr<=L1 && Nr<=Nr2)
  { Text[Nr-1] = Zeichen; Nr++;}
  return Text;
}

char * xxn(char * Txtein, char * Text, int Nr1, int Nr2 )/* Text in text[Nr] */
{ int Nr, L1, L2;
  Nr = Nr1; L1 = strlen(Text); L2 = strlen(Txtein);
  while(Nr>0 && Nr<=L1 && Nr<=Nr2 && Nr-Nr1<L2)
  { Text[Nr-1] = Txtein[Nr-Nr1]; Nr++;}
  return Text;
}

char * xx11(char * Text1, char * Text2 ) /* text + text to text */
{ char * Text;
  Text = (char *) calloc(strlen(Text1)+strlen(Text2)+1, sizeof(char));
  strcat(Text,Text1);
  strcat(Text,Text2);
  return Text;
}

char * xx1(char * Text1, char * Text2 ) /* text + text to text */
{ char * Text;                              /* free text1 */
  Text = (char *) calloc(strlen(Text1)+strlen(Text2)+1, sizeof(char));
  strcat(Text,Text1);
  strcat(Text,Text2);
  free(Text1);
  return Text;
}

char * xx0(char * Text1, char * Text2 ) /* text + text to text */
{ char * Text;                             /* free text1, text2 */
  Text = (char *) calloc(strlen(Text1)+strlen(Text2)+1, sizeof(char));
  strcat(Text,Text1);
  strcat(Text,Text2);
  if(strlen(Text1)!=0) free(Text1);
  if(strlen(Text2)!=0) free(Text2);
  return Text;
}

char * xx10(char * Text1, char * Text2 ) /* text + text to text */
{ char * Text;                              /* free text */
  Text = (char *) calloc(strlen(Text1)+strlen(Text2)+1, sizeof(char));
  strcat(Text,Text1);
  strcat(Text,Text2);
  free(Text2);
  return Text;
}

char * xmn(char * Text1, int Anzahl1, int Anzahl2 )
{ char * Text; int Laenge;       /* text[n,m] to text */
  if(Anzahl2>strlen(Text1))
         Laenge = strlen(Text1)-Anzahl1+1;
    else Laenge = Anzahl2-Anzahl1+1;
  if (Anzahl1>0 && Anzahl1<=strlen(Text1))
  { Text = (char *) calloc(Laenge+1, sizeof(char));
    strncat(Text,&Text1[Anzahl1-1],Laenge);
    return Text;
  } else return (char *) calloc(1, sizeof(char));
}

char * xmnf(char * Text1, int Anzahl1, int Anzahl2 )
{ char * Text;        /* text[n,m] to text; free text */
  if (Anzahl1>0 && Anzahl1<=Anzahl2)
  { Text = (char *) calloc(Anzahl2-Anzahl1+2, sizeof(char));
    strncat(Text,&Text1[Anzahl1-1],Anzahl2-Anzahl1+1);
    free(Text1);
    return Text;
  } else
  { free(Text1);
    return (char *) calloc(1, sizeof(char));
} }

char * xis(char * Von, char * Nach ) /* text to text; free text*/
{ if(Von!=Nach) free(Nach);
  return Von;
}

char xcn(char * Von, int Nr ) /* text to text; free text*/
{ if(Nr > 0 && Nr <= strlen(Von)) return Von[Nr-1];
  else return 0;
}

char * rx(char Bis , int Laenge, int upto) /* read to text; until Bis*/
{ char Text[7800]; char * Text2; char c; int i=0, Lng;
  Lng = Laenge<=0?7800:Laenge;
  if (upto<=2) /*  */
  { while(i<Lng && (c = getc(StdIn))!=Bis)
    { if(c==EOF) break;
      Text[i++] = c;
    }
  } if(c==EOF) FSEOF=1; else FSEOF=0;
  Text[i]=0;
  Text2 = (char *) calloc(i+1, sizeof(char));
  strcpy(Text2,Text);
  return Text2;
}

char Fpurge(FILE * Von)
{ char c; 
  while((c=getc(Von))!='\n'&&c!=' '&&c!=EOF&&c!='\t');
  return EOF;
}

char * rxf(FILE * Von, char Bis , int Laenge, int upto) /* read to text; until Bis*/
{ char Text[7800]; char * Text2; char c; int i=0, Lng;
  Lng = Laenge<=0?7800:Laenge;
  if (upto<=2) /*  */
  { while(i<Lng && (c = getc(Von))!=Bis)
    { if(c==EOF) break;
      Text[i++] = c;
    }
  } if(c==EOF) FSEOF=1; else FSEOF=0;
  Text[i]=0;
  Text2 = (char *) calloc(i+1, sizeof(char));
  strcpy(Text2,Text);
  return Text2;
}

void xco(char * Von, char * Nach,int wo ) /* text to textconst; free text*/
{ if(Von!=Nach) free(Nach);
  if(strlen(Nach)<strlen(Von)) perr(5,wo);
  strcpy(Nach,Von);
}

void alcp/* allocate && copy */
(char * Nach, int RefNach, char * Von, int RefVon, int size) 
{
}

int isin(int * classRef, int classNr, int IsItIn)
{ int Anz, i;
  if(IsItIn==0) return (classRef[1]==classNr);
  Anz = classRef[0];
  for(i=1;i<=Anz;i++)
  {if(classRef[i]==classNr) return 1;}
  return 0;
}

void ahochb(double * c,double * ci,double b,double bi)
{ double a, ai, r, phi;
  a = *c; ai = *ci;
  if(a==eee && ai==0.0)
  { r = pow(eee,b);
    a = r*cos(bi);
    ai = r*sin(bi);
  }
  else if(a>0.0 && ai==0.0)
  { r = log(a);
    b = b*r;
    bi = bi*r;
    r = pow(eee,b);
    a = r*cos(bi);
    ai = r*sin(bi);
  }
  else if(bi==0.0)
  { r = sqrt(a*a+ai*ai);
    if(r>0)
    { phi = b*acos(a/r);
      r = pow(r,b);
      a = r*cos(phi);
      ai = r*sin(phi);
    }
  }
  *c = a; *ci = ai;
  return;
}

double sinh(double x){ return (exp(x)-exp(-x))/2.0;}
double cosh(double x){ return (exp(x)+exp(-x))/2.0;}
double tanh(double x)
{ return (exp(x)-exp(-x))/(exp(x)+exp(-x));}
double asinh(double x){ return log(x+sqrt(x*x+1));}
double acosh(double x){ return log(x+sqrt(x*x-1));}
double atanh(double x){ return 0.5*log((x+1)/(1-x));}
double acoth(double x){ return 0.5*log((x+1)/(x-1));}

double log2(double x)
{ return log(x)/log(2);}
double acot(double x)
{ if(x>0) return atan(1/x);
  else return atan(1/x)+pipipi;}
void expc(double * x, double *y)
{ double a, b;
  a = eee; b = 0; ahochb(&a, &b, *x, *y); *x = a; *y = b; return;}
void logc(double *x, double *y)
{ double a, b; a=*x; b=*y;
  *x = log(sqrt(a*a+b*b)); *y = atan(b/a); return;}
void log10c(double *x, double *y)
{ double a, b; a=*x; b=*y;
  *x = log10(sqrt(a*a+b*b)); *y = log10(eee)*atan(b/a); return;}
void log2c(double *x, double *y)
{ double a, b; a=*x; b=*y;
  *x = log2(sqrt(a*a+b*b)); *y = log2(eee)*atan(b/a); return;}
void sinc(double *x, double *y)
{ double a, b; a=*x; b=*y;
  *x = sin(a)*cosh(b); *y = cos(a)*sinh(b); return;}
void cosc(double *x, double *y)
{ double a, b; a=*x; b=*y;
  *x = cos(a)*cosh(b); *y = -sin(a)*sinh(b); return;}
void tanc(double *x, double *y)
{ double num, a, b; a=2*(*x); b=2*(*y);
  num = 1/(cos(a) + cosh(b));
  *x = sin(a)*num;
  *y = sinh(b)*num;
  return;
}
void asinc(double *x, double *y) 
{fprintf(StdErr,"arcsin(complex)not implemented!\n");return ;}
void acosc(double *x, double *y) 
{fprintf(StdErr,"arccos(complex)not implemented!\n");return ;}
void atanc(double *x, double *y) 
{fprintf(StdErr,"arctan(complex)not implemented!\n");return ;}
void acotc(double *x, double *y) 
{fprintf(StdErr,"arccot(complex)not implemented!\n");return ;}
void asinhc(double *x, double *y) 
{fprintf(StdErr,"arsinh(complex)not implemented!\n");return ;}
void acoshc(double *x, double *y) 
{fprintf(StdErr,"arcosh(complex)not implemented!\n");return ;}
void atanhc(double *x, double *y) 
{fprintf(StdErr,"artanh(complex)not implemented!\n");return ;}
void acothc(double *x, double *y) 
{fprintf(StdErr,"arcoth(complex)not implemented!\n");return ;}
void cotc(double *x, double *y)
{ double num, a, b; a=2*(*x); b=2*(*y);
  num = 1/(cos(a) - cosh(b));
  *x = -sin(a)*num;
  *y = sinh(b)*num;
  return;
}
void sinhc(double *x, double *y)
{ double a, b; a=*x; b=*y;
  *x = sinh(a)*cos(b); *y = cosh(a)*sin(b); return;}
void coshc(double *x, double *y)
{ double a, b; a=*x; b=*y;
  *x = cosh(a)*cos(b); *y = sinh(a)*sin(b); return;}
void tanhc(double *x, double *y)
{ double num, a, b; a=2*(*x); b=2*(*y);
  num = 1/(cosh(a) + cos(b));
  *x = sinh(a)*num;
  *y = sin(b)*num;
  return;
}
void cothc(double *x, double *y)
{ double num, a, b; a=2*(*x); b=2*(*y);
  num = 1/(cosh(a) - cos(b));
  *x = sinh(a)*num;
  *y = -sin(b)*num;
  return;
}
